import base64
from urllib.request import Request, ProxyHandler, build_opener

SFDE_USERNAME = '<username>'
SFDE_PASSWORD = '<password>'
PROXIES = {'http': 'http://<username>:<password>@rb-proxy-de.bosch.com:8080',
           'https': 'https://<username>:<password>@rb-proxy-de.bosch.com:8080'}
sfdeProject = 'demo'

def basics_auth(username, password):
    """ Method which return a base 64 basic authentication
    :param username: your SFDE username
    :param password: your password username
    :return: returns string
    """
    credential = username + ':' + password
    encoded_credential = credential.encode('ascii')
    b_encoded_credential = base64.b64encode(encoded_credential)
    b_encoded_credential = b_encoded_credential.decode('ascii')
    b_auth = b_encoded_credential
    return 'Basic %s' % b_auth


def make_request(server_url, post_data=None):
    """ Method which handel a request and return response as json
    :param server_url:  the url for the request
    :param post_data: post data for Post method
    :return: content
    """
    proxy = ProxyHandler(PROXIES)
    opener = build_opener(proxy)
    r = Request(server_url + sfdeProject)

    sfde_b_auth = basics_auth(SFDE_USERNAME, SFDE_PASSWORD)
    r.add_header('Authorization', sfde_b_auth)
    r.add_header('Content-Type', 'application/json')
    r.add_header('Accept', 'application/json')

    r_data = post_data
    r.data = r_data

    handle = opener.open(r)
    content = handle.read().decode('utf8')
    return content


def main():
    try:
        # Server and the api service details
        server = 'https://bosch-iot-insights.com'
        serviceBaseUrl = '/data-recorder-service/'
        service = 'v2/'

        payload = "{Python:'Hello World'}"
        url = server + serviceBaseUrl + service  # construction of the final url for the first POST request
        data = payload.encode("ascii")  # encoding format is ascii for the initial POST request
        res = make_request(url, data)

        print(res)
        print('Data was send to Project:' + sfdeProject)

    except IOError as e:
        print("Problem with the request..")
        print(e)
        print(e.read())

if __name__ == '__main__': main()